# Copyright (C) 2012-2014 Zammad Foundation, http://zammad-foundation.org/

class Organization < ApplicationModel
  load 'organization/assets.rb'
  include Organization::Assets
  extend Organization::Search
  include Organization::SearchIndex

  has_and_belongs_to_many :users
  has_many                :members,  :class_name => 'User'
  validates               :name,     :presence => true

  after_create            :notify_clients_after_create
  after_update            :notify_clients_after_update

  activity_stream_support  :role => 'Admin'
  history_support
  search_index_support

end